import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;






import java.awt.Toolkit;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;






import javax.swing.BorderFactory;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.LayoutStyle;
import javax.swing.WindowConstants;
import javax.swing.border.TitledBorder;

import java.util.LinkedList;

/**
 * La classe FramePrincipale estende JFrame è crea gui 
 * 
 * @author Santo Marchese
 *
 */
public class FramePrincipale extends JFrame 
{
	 /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	 JTextPane bitControllo;
	 JTextField input;
	 JLabel inputLabel;
     JButton jButtonApri;
	 JButton jButtonAvvia;
	 JButton jButtonExit;
	 JButton jButtonInvia;
	 JButton jButtonSalva;
	 JButton jButtonreset;

	 JLabel jLabelNumbitControllo;
	 JLabel jLabelTempEsecuzione;
     JLabel outputLabel;
	 JPanel jPanel1;
	 JPanel jPanel2;
	 JScrollPane jScrollPane1;
	 JScrollPane jScrollPane2;
	 JScrollPane jScrollPane4;
	 JTextArea jTextAreaTutorial;
	 JTextField jTextFieldTempEsecuzione;
	 JTextField jTextFieldtNumbitControllo;
	 JTextPane jTextPaneoutput;
	 JScrollPane outScroll = new JScrollPane();
	 GestioneDegliEventi event;
	 JScrollPane jScrollPane3;
	 String resultLoad;
	 String operazioni="";
	 String insert="";
	 String hammingString="";
	 Hamming hamming;
	 String tmp=""; 
	 boolean verifica=false;
	 LinkedList<HammingFile>listHamming;
	 LinkedList<String>liststring;
	 int numeroStringhe;
	 int lunghezzaMediaDelleStringhe;
	 float tempo=0;
	 String currentPathApri="";
	 String currentPathSalva="";
	public FramePrincipale()
	{   
		initComponents() ;
		resultLoad="";
		listHamming=new LinkedList<HammingFile>();
		liststring=new LinkedList<String>();
		numeroStringhe=0;
	    lunghezzaMediaDelleStringhe=0;
	}
	
	
	
	
	
	
	
	
		 private void initComponents() 
		 {  
			
	        event=new GestioneDegliEventi(this);
	        Font font=new Font("DejaVu Sans", 0, 12);
		    Color color=new Color(0, 51, 255);
	        jScrollPane1 = new JScrollPane();
	        jPanel2 = new JPanel();
	        jButtonAvvia = new JButton();
	        input = new JTextField();
	        outputLabel = new JLabel();
	        jButtonreset = new JButton();
	        jButtonExit = new JButton();
	        inputLabel = new JLabel();
	        jScrollPane4 = new JScrollPane();
	        jTextPaneoutput = new JTextPane();
	        jButtonApri = new JButton();
	        jButtonSalva = new JButton();
	        jButtonInvia = new JButton();
	        jLabelTempEsecuzione = new JLabel();
	        jTextFieldtNumbitControllo = new JTextField();
	        jLabelNumbitControllo = new JLabel();
	        jTextFieldTempEsecuzione = new JTextField();
	        jPanel1 = new JPanel();
	        jScrollPane2 = new JScrollPane();
	        jTextAreaTutorial = new JTextArea();
          

	        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

	        jPanel2.setBorder(BorderFactory.createTitledBorder(null, "Simulatore", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, font, color)); // NOI18N

	        jButtonAvvia.setFont(font);
	        jButtonAvvia.setText("Avvia");
	        jButtonAvvia.addActionListener(event);
           
	        input.setFont(font);
	        input.setHorizontalAlignment(JTextField.LEFT);

	        outputLabel.setFont(font);
	        outputLabel.setText("Output");

	        jButtonreset.setFont(font);
	        jButtonreset.setText("Reset");
	        jButtonreset.setEnabled(false);
	        jButtonreset.addActionListener(event);
	         

	        jButtonExit.setFont(font);
	        jButtonExit.setText("Esci");
	        
	        jButtonExit.addActionListener(event);

	        inputLabel.setFont(font);
	        inputLabel.setText("Input");

	        jTextPaneoutput.setEditable(false);
	        jTextPaneoutput.setFont(font);
	        jScrollPane4.setViewportView(jTextPaneoutput);

	        jButtonApri.setText("Apri");
	        jButtonApri.addActionListener(event); 
	        jButtonSalva.setFont(font);
	        jButtonSalva.setText("Salva");
	        jButtonSalva.setEnabled(false);
	        jButtonSalva.addActionListener(event);
          
	        jButtonInvia.setFont(font);
	        jButtonInvia.setText("Invia");
	        jButtonInvia.addActionListener(event);
	        jButtonInvia.setEnabled(false);
	        jLabelTempEsecuzione.setFont(font);
	        jLabelTempEsecuzione.setText("Tempo di esecuzione");

	        jTextFieldtNumbitControllo.setEditable(false);
	        jTextFieldtNumbitControllo.setFont(font);

	        jLabelNumbitControllo.setFont(font);
	        jLabelNumbitControllo.setText("Num. bit di controllo");

	        jTextFieldTempEsecuzione.setEditable(false);
	        jTextFieldTempEsecuzione.setFont(font);
	        
	        jPanel2.setBorder(BorderFactory.createTitledBorder(null, "Simulatore", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, font, color)); // NOI18N



	        GroupLayout jPanel2Layout = new GroupLayout(jPanel2);
	        jPanel2.setLayout(jPanel2Layout);
	        jPanel2Layout.setHorizontalGroup(
	            jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	            .addGroup(jPanel2Layout.createSequentialGroup()
	                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	                    .addGroup(jPanel2Layout.createSequentialGroup()
	                        .addGap(12, 12, 12)
	                        .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	                            .addComponent(inputLabel)
	                            .addComponent( jLabelNumbitControllo)
	                            .addComponent(jLabelTempEsecuzione)
	                            .addComponent(outputLabel))
	                        .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	                            .addGroup(jPanel2Layout.createSequentialGroup()
	                                .addGap(6, 6, 6)
	                                .addComponent(jButtonreset, GroupLayout.PREFERRED_SIZE, 96,GroupLayout.PREFERRED_SIZE)
	                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
	                                .addComponent(jButtonSalva, javax.swing.GroupLayout.PREFERRED_SIZE, 88, GroupLayout.PREFERRED_SIZE)
	                                .addGap(18, 18, 18)
	                                .addComponent(jButtonInvia, javax.swing.GroupLayout.PREFERRED_SIZE, 84, GroupLayout.PREFERRED_SIZE)
	                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                                .addComponent(jButtonExit, javax.swing.GroupLayout.PREFERRED_SIZE, 81, GroupLayout.PREFERRED_SIZE))
	                            .addGroup(jPanel2Layout.createSequentialGroup()
	                                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
	                                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	                                    .addComponent(input, javax.swing.GroupLayout.PREFERRED_SIZE, 366, GroupLayout.PREFERRED_SIZE)
	                                    .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.TRAILING, false)
	                                        .addComponent(jTextFieldtNumbitControllo, GroupLayout.Alignment.LEADING, GroupLayout.DEFAULT_SIZE, 68, Short.MAX_VALUE)
	                                        .addComponent(jTextFieldTempEsecuzione, GroupLayout.Alignment.LEADING))))
	                            .addGroup(jPanel2Layout.createSequentialGroup()
	                                .addGap(10, 10, 10)
	                                .addComponent(jScrollPane4, GroupLayout.PREFERRED_SIZE, 370, GroupLayout.PREFERRED_SIZE))))
	                    .addGroup(jPanel2Layout.createSequentialGroup()
	                        .addGap(293, 293, 293)
	                        .addComponent(jButtonAvvia, GroupLayout.PREFERRED_SIZE, 80, GroupLayout.PREFERRED_SIZE))
	                    .addGroup(jPanel2Layout.createSequentialGroup()
	                        .addGap(524, 524, 524)
	                        .addComponent(jButtonApri,GroupLayout.PREFERRED_SIZE, 75, GroupLayout.PREFERRED_SIZE)))
	                .addContainerGap(223, Short.MAX_VALUE))
	        );
	        jPanel2Layout.setVerticalGroup(
	            jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	            .addGroup(jPanel2Layout.createSequentialGroup()
	                .addGap(49, 49, 49)
	                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
	                    .addComponent(inputLabel)
	                    .addComponent(jButtonApri, GroupLayout.PREFERRED_SIZE, 24, GroupLayout.PREFERRED_SIZE)
	                    .addComponent(input, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
	                .addGap(53, 53, 53)
	                .addComponent(jButtonAvvia)
	                .addGap(22, 22, 22)
	                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
	                    .addComponent(jLabelNumbitControllo , GroupLayout.PREFERRED_SIZE, 27,GroupLayout.PREFERRED_SIZE)
	                    .addComponent(jTextFieldtNumbitControllo, GroupLayout.PREFERRED_SIZE,GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
	                .addGap(116, 116, 116)
	                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
	                    .addComponent(jLabelTempEsecuzione)
	                    .addComponent(jTextFieldTempEsecuzione, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
	                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	                    .addGroup(jPanel2Layout.createSequentialGroup()
	                        .addGap(40, 40, 40)
	                        .addComponent(jScrollPane4,GroupLayout.PREFERRED_SIZE, 123, GroupLayout.PREFERRED_SIZE))
	                    .addGroup(jPanel2Layout.createSequentialGroup()
	                        .addGap(98, 98, 98)
	                        .addComponent(outputLabel)))
	                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 47, Short.MAX_VALUE)
	                .addGroup(jPanel2Layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
	                    .addComponent(jButtonExit)
	                    .addComponent(jButtonreset)
	                    .addComponent(jButtonSalva)
	                    .addComponent(jButtonInvia))
	                .addGap(424, 424, 424))
	        );

	        jScrollPane1.setViewportView(jPanel2);

	        jPanel1.setBorder(BorderFactory.createTitledBorder(null, "Dettagli", TitledBorder.DEFAULT_JUSTIFICATION,TitledBorder.DEFAULT_POSITION, font, color)); // NOI18N

	        jTextAreaTutorial.setEditable(false);
	        jTextAreaTutorial.setColumns(20);
	      
	        jTextAreaTutorial.setLineWrap(true);
	        jTextAreaTutorial.setRows(5);
	      
	        jScrollPane2.setViewportView(jTextAreaTutorial);

	        GroupLayout jPanel1Layout = new GroupLayout(jPanel1);
	        jPanel1.setLayout(jPanel1Layout);
	        jPanel1Layout.setHorizontalGroup(
	            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	            .addComponent(jScrollPane2, GroupLayout.PREFERRED_SIZE, 341, GroupLayout.PREFERRED_SIZE)
	        );
	        jPanel1Layout.setVerticalGroup(
	            jPanel1Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	            .addComponent(jScrollPane2, GroupLayout.Alignment.TRAILING)
	        );

	       GroupLayout layout = new GroupLayout(getContentPane());
	        getContentPane().setLayout(layout);
	        layout.setHorizontalGroup(
	            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	            .addGroup(layout.createSequentialGroup()
	                .addContainerGap()
	                .addComponent(jScrollPane1, GroupLayout.PREFERRED_SIZE, 620, GroupLayout.PREFERRED_SIZE)
	                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
	                .addComponent(jPanel1, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
	                .addContainerGap(86, Short.MAX_VALUE))
	        );
	        layout.setVerticalGroup(
	            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	            .addGroup(layout.createSequentialGroup()
	                .addContainerGap()
	                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
	                    .addComponent(jScrollPane1, GroupLayout.DEFAULT_SIZE, 790, Short.MAX_VALUE)
	                    .addComponent(jPanel1, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
	        );

	        pack();
	    }// </editor
		
	
	
	
	public void reset() 
	{    input.setText(""); 
	    this.jButtonAvvia.setEnabled(true);
	    this.jButtonApri.setEnabled(true);
	     this.operazioni="";
	 	jTextFieldtNumbitControllo.setText("");
		
		 jTextPaneoutput.setText("");		
		 jTextFieldTempEsecuzione.setText("");
		 jTextAreaTutorial.setText("");
		 jButtonreset.setEnabled(false);
		 jButtonSalva.setEnabled(false);
		 jButtonInvia.setEnabled(false);
		 input.setEnabled(true);
		 listHamming=new LinkedList<HammingFile>();
		 numeroStringhe=0;
		 lunghezzaMediaDelleStringhe=0;
		 tempo=0;
	}
	
	public void avvia()
	
   {         
		this.jButtonApri.setEnabled(false);
		this.jButtonAvvia.setEnabled(false);
		 input.setEnabled(false);
		 
		this.operazioni="";
		if ((input.getText().length() > 0))
			
		{   jButtonreset.setEnabled(true);
			insert="La Stringa inserita è:"+input.getText();

			boolean flag = true;
			boolean ok = false;
			for (int i = 0; i < input.getText().length() && (flag); i++) 
			{
				if (input.getText().charAt(i) != '0'
						&& input.getText().charAt(i) != '1') {
					flag = false;
					JOptionPane.showMessageDialog(this,
							" Stringa binaria non valida", "Errore",
							JOptionPane.ERROR_MESSAGE);
					this.reset();
					ok = false;
				} else 
				{

					ok = true;

				}
			}
			if (ok) 
			{
				 numeroStringhe=1;
				 lunghezzaMediaDelleStringhe=input.getText().length();
				 
				long startTime = System.currentTimeMillis();
			    hamming = new Hamming(input.getText());
			    listHamming.add(new HammingFile(hamming));
				 tmp = hamming.getprintaddBitDicontrollo();
				
				jTextFieldtNumbitControllo.setText(""
						+ hamming.getnumeroDiBitDiControllo());
				
				
				for (int i = 0; i < hamming.getValoreIndexDellPotenzaDelDue().length; i++) {
					
					operazioni += "il bit controlla:\t"
							+ hamming.getValoreIndexDellPotenzaDelDue()[i]
							+ "\n"
							
							+ hamming
									.getBitDiControllo()
									.get(hamming
											.getValoreIndexDellPotenzaDelDue()[i])+"\nvalori dei rispettivi bit:"+hamming.getValori().get(hamming.getValoreIndexDellPotenzaDelDue()[i]).getList().toString()+"\n"+"xor:"+hamming.getValori().get(hamming.getValoreIndexDellPotenzaDelDue()[i]).getElement()
									
							+ "\n";

				}

				
				
				
				
				
				jTextAreaTutorial.setFont(new Font("Courier", Font.BOLD, 12));
				
				   jTextAreaTutorial.setText(""+operazioni);
				 hammingString=hamming.createHamming();
				
				 jTextPaneoutput.setFont(new Font("Courier", Font.BOLD, 14)); 
				jTextPaneoutput.setText(tmp + "\n" + hammingString);
				jButtonSalva.setEnabled(true);
				jButtonInvia.setEnabled(true);
				long endTime = System.currentTimeMillis();
				 tempo = (float) (endTime - startTime) / 1000;
				jTextFieldTempEsecuzione.setText("" + tempo +"s");
			}
			} else {
				JOptionPane.showMessageDialog(this,
						"Casella di testo è vuota", "Errore",
						JOptionPane.ERROR_MESSAGE);
				reset();
				
			}
		
		}

	/**
	 * il metodo  esegue la lettura da file di txt
	 * 
	 * 
	 * 
	 */
	
	
	public void ApriFile()
	{     
	     int sommaLunghezzaDelleStringhe=0;
		input.setEnabled(false);
		this.jButtonAvvia.setEnabled(false);
		this.jButtonInvia.setEnabled(false);
		this.jButtonApri.setEnabled(false);
		long startTime=0;
		JFileChooser dialogo = new JFileChooser(new File(currentPathApri));
		dialogo.setAcceptAllFileFilterUsed(false);
		 dialogo.setFileFilter(new MyFilter(".txt") );
		int risposta = dialogo.showOpenDialog((JFrame) null);

		if (risposta == JFileChooser.APPROVE_OPTION) 
		{ 



			try 
			{   
				startTime = System.currentTimeMillis(); 
				File dati = dialogo.getSelectedFile();
                
                this.currentPathApri=dati.getParent().toString();
              
                		 


				BufferedReader fileIn = new BufferedReader(new FileReader(dati));
				// inizializzo la stringa 


				String currentLine = fileIn.readLine();




				while (currentLine !=null) 
				{     
				  // creo un oggetto di Tipo Hamming 
					 Hamming hamming = new Hamming(currentLine);
					 sommaLunghezzaDelleStringhe+=currentLine.length();
					  listHamming.add(new HammingFile(hamming));
					  numeroStringhe++;
   				     resultLoad+="Stringa di input:"+ currentLine+","+"Stringa di output:"+hamming.createHamming()+"\n";

					currentLine = fileIn.readLine();

				}

				  fileIn.close();
				 jButtonreset.setEnabled(true);
				 jButtonSalva.setEnabled(true);
				 jTextPaneoutput.setFont(new Font("Courier", Font.BOLD, 12));
				jTextPaneoutput.setText(resultLoad);
				long endTime = System.currentTimeMillis(); 
				//calcolo  il tempo di eseguzione
				 tempo=(float)(endTime - startTime)/1000;
				 jTextFieldTempEsecuzione.setText(""+tempo+"s");
				 String result="";
				 for(int i=0;i<listHamming.size();i++)
				 {
					   //result+=listHamming.get(i).createHammingFile()+"\n";
					   result+=listHamming.get(i).print()+"\n";


				 }
				 result+="Numero di stringhe totali:"+numeroStringhe+"\n";
				 lunghezzaMediaDelleStringhe=sommaLunghezzaDelleStringhe/numeroStringhe;
				 result+="Lunghezza media delle stringhe e':"+lunghezzaMediaDelleStringhe+"\n";
				 result+="Tempo di esecuzione e':"+tempo+"s";
				 jTextAreaTutorial.setFont(new Font("Courier", Font.BOLD, 12));
				 jTextAreaTutorial.setText(result); 
				 
			  }catch (FileNotFoundException e) 
			  {
					// TODO Auto-generated catch block
					System.out.println(e.toString());
					e.printStackTrace();
			  } catch (IOException e) 
			  {
					// TODO Auto-generated catch block
					System.out.println(e.toString());
					e.printStackTrace();

					JOptionPane.showMessageDialog(this,
						    "Errore di lettura del file",
						    "Errore",
						    JOptionPane.ERROR_MESSAGE);
					 input.setEnabled(true);
			  } catch (NumberFormatException e)
			  {
				  jTextPaneoutput.setText("");
					JOptionPane.showMessageDialog(this,
						    "il Formato del file non è valido ",
						    "Errore",
						    JOptionPane.ERROR_MESSAGE);
					 input.setEnabled(true);

					ApriFile();


			} 

			}else
			{    this.jButtonApri.setEnabled(true);
				input.setEnabled(true);
			     this.jButtonAvvia.setEnabled(true);
				 jTextFieldTempEsecuzione.setText("");

			}





		}

	
	
	/**
	 * 
	 *  Il metodo salva la stringa di hamming
	 * 
	 */
	public void salvaFile()
	 {
		    JFileChooser dialogo = new JFileChooser(new File(currentPathSalva));
			 dialogo.setAcceptAllFileFilterUsed(false);
			 dialogo.setFileFilter(new MyFilter(".txt") ); 
              String nomeFile=dialogo.getCurrentDirectory().toString()+"/untitled";
            
              File file=new File(nomeFile);
			 dialogo.setSelectedFile(file);
			 int risposta = dialogo.showSaveDialog(((JFrame) null));
			 if (risposta == JFileChooser.APPROVE_OPTION) 
			 {
			
               
				
				  file=new File(dialogo.getSelectedFile()+dialogo.getFileFilter().getDescription());
                  currentPathSalva=file.getParentFile().toString();
                 
				 boolean exists = file.exists();
				 
				 
				 if(!exists)
				 {
					 FileWriter w;
					    try 
					    {  
							 w=new FileWriter(file);

							 BufferedWriter  b=new BufferedWriter (w);

							 for(int i=0;i<listHamming.size();i++)
							 {


								 b.write(listHamming.get(i).print());
								 b.write("\n");
								 b.flush();

							 } 
							 b.write ("Numero di stringhe totali:"+numeroStringhe+"\n");
							 b.write("Lunghezza media delle stringhe e':"+lunghezzaMediaDelleStringhe+"\n");
							 b.write("Tempo di esecuzione e':"+tempo+"s");
							 b.close();

						} catch (IOException e) 
						{
							// TODO Auto-generated catch block
							System.out.println(e.toString());
							e.printStackTrace();
						}

				 }else
				 {

					 JOptionPane.showMessageDialog(this,
							    "File Esistente",
							    "Attenzione",

							    JOptionPane.WARNING_MESSAGE);

					 salvaFile();

				 }


			 }	 




	 }
	 
	 
	 /**
	  *  il metodo invia la stringa di hamming.
	  *  Controlla se la parità corretta,in caso contrario avvisa 
	  *  l'utente se vuole correggere l'errore della stringa inviata 
	  *  
	  * 
	  */
	 public void invia()
	 {
		 String tmp="";
		 jTextAreaTutorial.setText("");
		
		     
		    
		     String ricevuta=hamming.createError(hammingString);
			 hamming.setStringHamming(ricevuta);
			 // verifico se la stringa ricevuta è corretta
			 String controllo=hamming.getCorrect();
			 
			
			 if(!controllo.equals("-1"))
				 
			   {    
				 
				    for(int i=0;i<hamming.getErrorBitDiParita().size();i++){
				        tmp+="Bit parità di\t "+hamming.getErrorBitDiParita().get(i)+"\t"+"non corretto"+"\n";}  
			    	 int n = JOptionPane.showConfirmDialog(
						    this,
						    " Vuoi correggere la stringa?",
						    "La stringa ricevuta è errata",
						    JOptionPane.YES_NO_OPTION);	
			    	
					 
			    	        if(n==  JOptionPane.YES_NO_OPTION)
			    	        {   tmp+="\n";
			    	        	tmp+="La somma dei bit di parità errati ci dà l'indice errato:"+hamming.IndexBitErrato();
			    	        	jTextAreaTutorial.setText(tmp);
			    	        	 jTextPaneoutput.setFont(new Font("Courier", Font.BOLD, 12));
			    	            jTextPaneoutput.setText( "inviata:" +"\t"+ hammingString+"\n"+"ricevuta:"+"\t"+ricevuta+"\n"+"Corretta:\t"+hamming.getCorrect());
							   jTextPaneoutput.setEditable(false);
							 
							
				
			    	        }else
			    	        {       jTextPaneoutput.setFont(new Font("Courier", Font.BOLD, 12));
			    	              
			    	        	  jTextPaneoutput.setText( "inviata:" +"\t"+ hammingString+"\n"+"ricevuta:"+"\t"+ricevuta);
			    	        	
			    	        }
				 

				 
			 }else
			 {
				 
				 JOptionPane.showMessageDialog(this,
						    "La stringa ricevuta è corretta.");
				 
				 jTextPaneoutput.setFont(new Font("Courier", Font.BOLD, 12));
				 jTextPaneoutput.setText( "inviata:" +"\t"+ hammingString+"\n"+"ricevuta:"+"\t"+ricevuta); 
			 }
						 
			  
			 
			
			
				
			
			
			 
			 
			
			 
			 
			 
		 
	 }
	 
	 

	}

